prepareForHDF5 <- function( counts, reference = NULL, stratifyDeletions = FALSE ){
  ret <- list()
  ret$Counts <- counts[-c(grep("-", dimnames(counts)[[1]])),,,drop=FALSE]
  ret$Coverages <- apply( ret$Counts, c(2,3), sum)
  if( stratifyDeletions ){
    ret$Deletions <- counts[c("-.front","-.mid","-.back"),,,drop=FALSE]  
  }else{
    ret$Deletions <- apply( counts[c("-.front","-.mid","-.back"),,,drop=FALSE], c(2,3), sum )
  }
  if( !is.null(reference) ){
    ref <- encodeDNAString( reference ) + 1
  }else{
    #ref <- apply(ret$Counts[1:4,1,] + ret$Counts[1:4,2,] + ret$Counts[5:8,1,] + ret$Counts[5:8,2,] + ret$Counts[9:12,1,] + ret$Counts[9:12,2,], 2, which.max)
    ref <- max.col(t(ret$Counts[1:4,1,] + ret$Counts[1:4,2,] + ret$Counts[5:8,1,] + ret$Counts[5:8,2,] + ret$Counts[9:12,1,] + ret$Counts[9:12,2,]), "first")
  }
  for( base in 1:4){
    idxs = which( ref == base )
    for( strand in 1:2){
      ret$Counts[base, strand, idxs] <- 0
      ret$Counts[base + 4, strand, idxs] <- 0
      ret$Counts[base + 8, strand, idxs] <- 0 
    }
  }
  ret$Reference <- ref - 1 #the tally file encodes the reference as A=0,C=1,G=2,T=3
  return(ret)
}