tallyBAM = function(file, chr, start, stop, q=25, ncycles = 0, max.depth=1000000, verbose=FALSE, reference = NULL){
  region = paste(chr,":",start,"-",stop, sep="")
  result = .C("_tallyBAM",
              as.character(file),
              as.character(chr),
              as.integer(start),
              as.integer(stop),
              vector("integer",(stop-start+1)*15*2),
              as.integer(q),
              as.integer(2),
              as.integer(ncycles),
              as.integer(max.depth),
              as.integer(verbose),
              PACKAGE="h5vc"
  )[[5]]
  a <- array(
    result,
    dim = c(15, 2, stop - start + 1),
    dimnames = list( c(paste( c("A","C","G","T"), rep( c("front","mid","back"), each=4 ), sep="." ), "-.front", "-.mid", "-.back"), c("+", "-"), NULL)
  )
  if(!is.null(reference)){
    return( prepareForHDF5( a, reference ) )
  }else{
    return(a) 
  }
}